/**
 * This class represents a simulation for a polygon with 4 sides
 */
public class Rectangle extends Polygon {

    /**
     * Constructor for the class with multiple args
     * @param sides multiple sides for this rectangle
     */
    public Rectangle(double ...sides) {
        super(sides);
    }


    @Override
    public double calculateArea() {
        double a = super.getSides().get(0);
        double b = super.getSides().get(1);
        double c= super.getSides().get(2);

        if (a==b)
            return b*c;
        else if (b==c)
            return a*c;
        else
            return a*b;
    }

    @Override
    public void draw() {
        System.out.println("Type: Rectangle\nPerimeter: " + this.calculatePerimeter()+ "\nArea: "
                + this.calculateArea());
    }


    @Override
    public String toString() {
        return "Type: Rectangle with sides: "+super.getSides();
    }

    @Override
    public boolean equals(Object object) {
        if (this == object) return true;
        if (object == null || getClass() != object.getClass()) return false;
        if (!super.equals(object)) return false;
        Rectangle rectangle = (Rectangle) object;
        return this.getSides().equals(rectangle.getSides());
    }

    /**
     * @return true if the rectangle is a square
     */
    public boolean isSquare() {
        double a = super.getSides().get(0);
        double b = super.getSides().get(1);
        double c = super.getSides().get(1);
        return (a == b && b==c);
    }
}